using Indotalent.Infrastructure.Database;
using MediatR;
using Microsoft.EntityFrameworkCore;

namespace Indotalent.Features.Thirdparty.VendorCategory.Cqrs;

public class GetVendorCategoryByIdResponse
{
    public string? Id { get; set; }
    public string? Name { get; set; }
    public string? Description { get; set; }
    public DateTimeOffset? CreatedAt { get; set; }
    public string? CreatedBy { get; set; }
    public DateTimeOffset? UpdatedAt { get; set; }
    public string? UpdatedBy { get; set; }
}

public record GetVendorCategoryByIdQuery(string Id) : IRequest<GetVendorCategoryByIdResponse?>;

public class GetVendorCategoryByIdHandler : IRequestHandler<GetVendorCategoryByIdQuery, GetVendorCategoryByIdResponse?>
{
    private readonly AppDbContext _context;

    public GetVendorCategoryByIdHandler(AppDbContext context) => _context = context;

    public async Task<GetVendorCategoryByIdResponse?> Handle(GetVendorCategoryByIdQuery request, CancellationToken cancellationToken)
    {
        return await _context.VendorCategory
            .AsNoTracking()
            .Where(x => x.Id == request.Id)
            .Select(x => new GetVendorCategoryByIdResponse
            {
                Id = x.Id,
                Name = x.Name,
                Description = x.Description,
                CreatedAt = x.CreatedAt,
                CreatedBy = x.CreatedBy,
                UpdatedAt = x.UpdatedAt,
                UpdatedBy = x.UpdatedBy,
            })
            .FirstOrDefaultAsync(cancellationToken);
    }
}